Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jfree.chart.renderer.xy
Class XYDifferenceRenderer

    java.lang.Object
      org.jfree.chart.renderer.AbstractRenderer
          org.jfree.chart.renderer.xy.AbstractXYItemRenderer
              org.jfree.chart.renderer.xy.XYDifferenceRenderer

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, LegendItemSource, XYItemRenderer, org.jfree.util.PublicCloneable

    public class XYDifferenceRenderer

extends AbstractXYItemRenderer
implements XYItemRenderer, java.lang.Cloneable, org.jfree.util.PublicCloneable, java.io.Serializable

A renderer for an `XYPlot` that highlights the differences between two series. The renderer expects a dataset that:

- has exactly two series;
- each series has the same x-values;
- no `null` values;

See Also:
  Serialized Form

Field Summary

Fields inherited from class org.jfree.chart.renderer.AbstractRenderer
`DEFAULT_OUTLINE_PAINT, DEFAULT_OUTLINE_STROKE, DEFAULT_PAINT, DEFAULT_SHAPE, DEFAULT_STROKE, DEFAULT_VALUE_LABEL_FONT, DEFAULT_VALUE_LABEL_PAINT, ZERO`

Constructor Summary
`XYDifferenceRenderer()` Creates a new renderer with default attributes.
`XYDifferenceRenderer(java.awt.Paint positivePaint, java.awt.Paint negativePaint, boolean shapes)` Creates a new renderer.

Method Summary
`java.lang.Object` | `clone()` Returns a clone of the renderer.
`void` | `drawItem(java.awt.Graphics2D g2, XYItemRendererState state, java.awt.geom.Rectangle2D dataArea, PlotRenderingInfo info, XYPlot plot, ValueAxis domainAxis, ValueAxis rangeAxis, XYDataset dataset, int series, int item, CrosshairState crosshairState, int pass)` Draws the visual representation of a single data item.
`protected void` | `drawItemPass0(java.awt.Graphics2D g2, java.awt.geom.Rectangle2D dataArea, PlotRenderingInfo info, XYPlot plot, ValueAxis domainAxis, ValueAxis rangeAxis, XYDataset dataset, int series, int item, CrosshairState crosshairState)` Draws the visual representation of a single data item, first pass.
`protected void` | `drawItemPass1(java.awt.Graphics2D g2, java.awt.geom.Rectangle2D dataArea, PlotRenderingInfo info, XYPlot plot, ValueAxis domainAxis, ValueAxis rangeAxis, XYDataset dataset, int series, int item, CrosshairState crosshairState)` Draws the visual representation of a single data item, second pass.
`boolean` | `equals(java.lang.Object obj)` Tests this renderer for equality with an arbitrary object.
`LegendItem` | `getLegendItem(int datasetIndex, int series)` Returns a default legend item for the specified series.
`java.awt.Shape` | `getLegendLine()` Returns the shape used to represent a line in the legend.
`protected java.awt.Shape` | `getNegativeArea(float x0, float y0A, float y0B, float x1, float y1A, float y1B, PlotOrientation orientation)` Returns the negative area for a cross-over section.
`java.awt.Paint` | `getNegativePaint()` Returns the paint used to highlight negative differences.
`int` | `getPassCount()` Returns `2`, the number of passes required by the renderer.
`protected java.awt.Shape` | `getPositiveArea(float x0, float y0A, float y0B, float x1, float y1A, float y1B, PlotOrientation orientation)` Returns the positive area for a crossover point.
`java.awt.Paint` | `getPositivePaint()` Returns the paint used to highlight positive differences.
`boolean` | `getRoundXCoordinates()` Returns the flag that controls whether or not the x-coordinates (in Java2D space) are rounded to integer values.
`boolean` | `getShapesVisible()` Returns a flag that controls whether or not shapes are drawn for each data value.
`XYItemRendererState` | `initialise(java.awt.Graphics2D g2, java.awt.geom.Rectangle2D dataArea, XYPlot plot, XYDataset data, PlotRenderingInfo info)` Initialises the renderer and returns a state object that should be passed to subsequent calls to the drawItem() method.
`void` | `setLegendLine(java.awt.Shape line)` Sets the shape used as a line in each legend item and sends a `RendererChangeEvent` to all registered listeners.
`void` | `setNegativePaint(java.awt.Paint paint)` Sets the paint used to highlight negative differences.
`void` | `setPositivePaint(java.awt.Paint paint)` Sets the paint used to highlight positive differences.
`void` | `setRoundXCoordinates(boolean round)` Sets the flag that controls whether or not the x-coordinates (in Java2D space) are rounded to integer values, and sends a `RendererChangeEvent` to all registered listeners.
`void` | `setShapesVisible(boolean flag)` Sets a flag that controls whether or not shapes are drawn for each data value.

Methods inherited from class org.jfree.chart.renderer.xy.AbstractXYItemRenderer
`addAnnotation, addAnnotation, addEntity, calculateDomainMarkerTextAnchorPoint, drawAnnotations, drawDomainGridLine, drawDomainLine, drawDomainMarker, drawItemLabel, drawRangeLine, drawRangeMarker, fillDomainGridBand, fillRangeGridBand, findDomainBounds, findRangeBounds, getBaseItemLabelGenerator, getBaseToolTipGenerator, getDefaultEntityRadius, getDrawingSupplier, getItemLabelGenerator, getItemLabelGenerator, getLegendItemLabelGenerator, getLegendItems, getLegendItemToolTipGenerator, getLegendItemURLGenerator, getPlot, getSeriesItemLabelGenerator, getSeriesToolTipGenerator, getToolTipGenerator, getToolTipGenerator, getURLGenerator, removeAnnotation, removeAnnotations, setBaseItemLabelGenerator, setBaseToolTipGenerator, setDefaultEntityRadius, setItemLabelGenerator, setLegendItemLabelGenerator, setLegendItemToolTipGenerator, setLegendItemURLGenerator, setPlot, setSeriesItemLabelGenerator, setSeriesToolTipGenerator, setToolTipGenerator, setURLGenerator, updateCrosshairValues, updateCrosshairValues`

Methods inherited from class org.jfree.chart.renderer.AbstractRenderer
`addChangeListener, calculateLabelAnchorPoint, fireChangeEvent, getBaseCreateEntities, getBaseFillPaint, getBaseItemLabelFont, getBaseItemLabelPaint, getBaseItemLabelsVisible, getBaseNegativeItemLabelPosition, getBaseOutlinePaint, getBaseOutlineStroke, getBasePaint, getBasePositiveItemLabelPosition, getBaseSeriesVisible, getBaseSeriesVisibleInLegend, getBaseShape, getBaseStroke, getCreateEntities, getItemCreateEntity, getItemFillPaint, getItemLabelAnchorOffset, getItemLabelFont, getItemLabelFont, getItemLabelPaint, getItemLabelPaint, getItemOutlinePaint, getItemOutlineStroke, getItemPaint, getItemShape, getItemStroke, getItemVisible, getNegativeItemLabelPosition, getNegativeItemLabelPosition, getPositiveItemLabelPosition, getPositiveItemLabelPosition, getSeriesCreateEntities, getSeriesFillPaint, getSeriesItemLabelFont, getSeriesItemLabelPaint, getSeriesNegativeItemLabelPosition, getSeriesOutlinePaint, getSeriesOutlineStroke, getSeriesPaint, getSeriesPositiveItemLabelPosition, getSeriesShape, getSeriesStroke, getSeriesVisible, getSeriesVisible, getSeriesVisibleInLegend, getSeriesVisibleInLegend, hashCode, hasListener, isItemLabelVisible, isSeriesItemLabelsVisible, isSeriesVisible, isSeriesVisibleInLegend, notifyListeners, removeChangeListener, setBaseCreateEntities, setBaseCreateEntities, setBaseFillPaint, setBaseFillPaint, setBaseItemLabelFont, setBaseItemLabelFont, setBaseItemLabelPaint, setBaseItemLabelPaint, setBaseItemLabelsVisible, setBaseItemLabelsVisible, setBaseItemLabelsVisible, setBaseNegativeItemLabelPosition, setBaseNegativeItemLabelPosition, setBaseOutlinePaint, setBaseOutlinePaint, setBaseOutlineStroke, setBaseOutlineStroke, setBasePaint, setBasePaint, setBasePositiveItemLabelPosition, setBasePositiveItemLabelPosition, setBaseSeriesVisible, setBaseSeriesVisible, setBaseSeriesVisibleInLegend, setBaseSeriesVisibleInLegend, setBaseShape, setBaseShape, setBaseStroke, setBaseStroke, setCreateEntities, setCreateEntities, setFillPaint, setFillPaint, setItemLabelAnchorOffset, setItemLabelFont, setItemLabelFont, setItemLabelPaint, setItemLabelPaint, setItemLabelsVisible, setItemLabelsVisible, setItemLabelsVisible, setNegativeItemLabelPosition, setNegativeItemLabelPosition, setOutlinePaint, setOutlinePaint, setOutlineStroke, setOutlineStroke, setPaint, setPaint, setPositiveItemLabelPosition, setPositiveItemLabelPosition, setSeriesCreateEntities, setSeriesCreateEntities, setSeriesFillPaint, setSeriesFillPaint, setSeriesItemLabelFont, setSeriesItemLabelFont, setSeriesItemLabelPaint, setSeriesItemLabelPaint, setSeriesItemLabelsVisible, setSeriesItemLabelsVisible, setSeriesItemLabelsVisible, setSeriesNegativeItemLabelPosition, setSeriesNegativeItemLabelPosition, setSeriesOutlinePaint, setSeriesOutlinePaint, setSeriesOutlineStroke, setSeriesOutlineStroke, setSeriesPaint, setSeriesPaint, setSeriesPositiveItemLabelPosition, setSeriesPositiveItemLabelPosition, setSeriesShape, setSeriesShape, setSeriesStroke, setSeriesStroke, setSeriesVisible, setSeriesVisible, setSeriesVisible, setSeriesVisible, setSeriesVisibleInLegend, setSeriesVisibleInLegend, setSeriesVisibleInLegend, setSeriesVisibleInLegend, setShape, setShape, setStroke, setStroke`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.jfree.chart.renderer.xy.XYItemRenderer
`addAnnotation, addAnnotation, addChangeListener, drawAnnotations, drawDomainGridLine, drawDomainMarker, drawRangeLine, drawRangeMarker, fillDomainGridBand, fillRangeGridBand, findDomainBounds, findRangeBounds, getBaseItemLabelFont, getBaseItemLabelGenerator, getBaseItemLabelPaint, getBaseItemLabelsVisible, getBaseNegativeItemLabelPosition, getBaseOutlinePaint, getBaseOutlineStroke, getBasePaint, getBasePositiveItemLabelPosition, getBaseSeriesVisible, getBaseSeriesVisibleInLegend, getBaseShape, getBaseStroke, getBaseToolTipGenerator, getItemLabelFont, getItemLabelFont, getItemLabelGenerator, getItemLabelPaint, getItemLabelPaint, getItemOutlinePaint, getItemOutlineStroke, getItemPaint, getItemShape, getItemStroke, getItemVisible, getLegendItemLabelGenerator, getNegativeItemLabelPosition, getNegativeItemLabelPosition, getPlot, getPositiveItemLabelPosition, getPositiveItemLabelPosition, getSeriesItemLabelFont, getSeriesItemLabelGenerator, getSeriesItemLabelPaint, getSeriesNegativeItemLabelPosition, getSeriesOutlinePaint, getSeriesOutlineStroke, getSeriesPaint, getSeriesPositiveItemLabelPosition, getSeriesShape, getSeriesStroke, getSeriesToolTipGenerator, getSeriesVisible, getSeriesVisible, getSeriesVisibleInLegend, getSeriesVisibleInLegend, getToolTipGenerator, getURLGenerator, isItemLabelVisible, isSeriesItemLabelsVisible, isSeriesVisible, isSeriesVisibleInLegend, removeAnnotation, removeAnnotations, removeChangeListener, setBaseItemLabelFont, setBaseItemLabelGenerator, setBaseItemLabelPaint, setBaseItemLabelsVisible, setBaseItemLabelsVisible, setBaseItemLabelsVisible, setBaseNegativeItemLabelPosition, setBaseNegativeItemLabelPosition, setBaseOutlinePaint, setBaseOutlineStroke, setBasePaint, setBasePositiveItemLabelPosition, setBasePositiveItemLabelPosition, setBaseSeriesVisible, setBaseSeriesVisible, setBaseSeriesVisibleInLegend, setBaseSeriesVisibleInLegend, setBaseShape, setBaseStroke, setBaseToolTipGenerator, setItemLabelFont, setItemLabelGenerator, setItemLabelPaint, setItemLabelsVisible, setItemLabelsVisible, setItemLabelsVisible, setLegendItemLabelGenerator, setNegativeItemLabelPosition, setNegativeItemLabelPosition, setOutlinePaint, setOutlineStroke, setPaint, setPlot, setPositiveItemLabelPosition, setPositiveItemLabelPosition, setSeriesItemLabelFont, setSeriesItemLabelGenerator, setSeriesItemLabelPaint, setSeriesItemLabelsVisible, setSeriesItemLabelsVisible, setSeriesItemLabelsVisible, setSeriesNegativeItemLabelPosition, setSeriesNegativeItemLabelPosition, setSeriesOutlinePaint, setSeriesOutlineStroke, setSeriesPaint, setSeriesPositiveItemLabelPosition, setSeriesPositiveItemLabelPosition, setSeriesShape, setSeriesStroke, setSeriesToolTipGenerator, setSeriesVisible, setSeriesVisible, setSeriesVisible, setSeriesVisible, setSeriesVisibleInLegend, setSeriesVisibleInLegend, setSeriesVisibleInLegend, setSeriesVisibleInLegend, setShape, setStroke, setToolTipGenerator, setURLGenerator`

Methods inherited from interface org.jfree.chart.LegendItemSource
`getLegendItems`

Constructor Detail

### XYDifferenceRenderer

    public XYDifferenceRenderer()

  Creates a new renderer with default attributes.

### XYDifferenceRenderer

    public XYDifferenceRenderer(java.awt.Paint positivePaint,
                                java.awt.Paint negativePaint,
                                boolean shapes)

  Creates a new renderer.

  Parameters:
    `positivePaint` - the highlight color for positive differences (`null` not permitted).
    `negativePaint` - the highlight color for negative differences (`null` not permitted).
    `shapes` - draw shapes?

Method Detail

### getPositivePaint

    public java.awt.Paint getPositivePaint()

  Returns the paint used to highlight positive differences.

  Returns:
    The paint (never `null`).
  See Also:
    `setPositivePaint(Paint)`

### setPositivePaint

    public void setPositivePaint(java.awt.Paint paint)

  Sets the paint used to highlight positive differences.

  Parameters:
    `paint` - the paint (`null` not permitted).
  See Also:
    `getPositivePaint()`

### getNegativePaint

    public java.awt.Paint getNegativePaint()

  Returns the paint used to highlight negative differences.

  Returns:
    The paint (never `null`).
  See Also:
    `setNegativePaint(Paint)`

### setNegativePaint

    public void setNegativePaint(java.awt.Paint paint)

  Sets the paint used to highlight negative differences.

  Parameters:
    `paint` - the paint (`null` not permitted).
  See Also:
    `getNegativePaint()`

### getShapesVisible

    public boolean getShapesVisible()

  Returns a flag that controls whether or not shapes are drawn for each data value.

  Returns:
    A boolean.
  See Also:
    `setShapesVisible(boolean)`

### setShapesVisible

    public void setShapesVisible(boolean flag)

  Sets a flag that controls whether or not shapes are drawn for each data value.

  Parameters:
    `flag` - the flag.
  See Also:
    `getShapesVisible()`

### getLegendLine

    public java.awt.Shape getLegendLine()

  Returns the shape used to represent a line in the legend.

  Returns:
    The legend line (never `null`).
  See Also:
    `setLegendLine(Shape)`

### setLegendLine

    public void setLegendLine(java.awt.Shape line)

  Sets the shape used as a line in each legend item and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `line` - the line (`null` not permitted).
  See Also:
    `getLegendLine()`

### getRoundXCoordinates

    public boolean getRoundXCoordinates()

  Returns the flag that controls whether or not the x-coordinates (in Java2D space) are rounded to integer values.

  Returns:
    The flag.
  Since:
    1.0.4
  See Also:
    `setRoundXCoordinates(boolean)`

### setRoundXCoordinates

    public void setRoundXCoordinates(boolean round)

  Sets the flag that controls whether or not the x-coordinates (in Java2D space) are rounded to integer values, and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `round` - the new flag value.
  Since:
    1.0.4
  See Also:
    `getRoundXCoordinates()`

### initialise

    public XYItemRendererState initialise(java.awt.Graphics2D g2,
                                          java.awt.geom.Rectangle2D dataArea,
                                          XYPlot plot,
                                          XYDataset data,
                                          PlotRenderingInfo info)

  Initialises the renderer and returns a state object that should be passed to subsequent calls to the drawItem() method. This method will be called before the first item is rendered, giving the renderer an opportunity to initialise any state information it wants to maintain. The renderer can do nothing if it chooses.

  Specified by:
    `initialise` in interface `XYItemRenderer`
  Overrides:
    `initialise` in class `AbstractXYItemRenderer`
  Parameters:
    `g2` - the graphics device.
    `dataArea` - the area inside the axes.
    `plot` - the plot.
    `data` - the data.
    `info` - an optional info collection object to return data back to the caller.
  Returns:
    A state object.

### getPassCount

    public int getPassCount()

  Returns `2`, the number of passes required by the renderer. The `XYPlot` will run through the dataset this number of times.

  Specified by:
    `getPassCount` in interface `XYItemRenderer`
  Overrides:
    `getPassCount` in class `AbstractXYItemRenderer`
  Returns:
    The number of passes required by the renderer.

### drawItem

    public void drawItem(java.awt.Graphics2D g2,
                         XYItemRendererState state,
                         java.awt.geom.Rectangle2D dataArea,
                         PlotRenderingInfo info,
                         XYPlot plot,
                         ValueAxis domainAxis,
                         ValueAxis rangeAxis,
                         XYDataset dataset,
                         int series,
                         int item,
                         CrosshairState crosshairState,
                         int pass)

  Draws the visual representation of a single data item.

  Specified by:
    `drawItem` in interface `XYItemRenderer`
  Parameters:
    `g2` - the graphics device.
    `state` - the renderer state.
    `dataArea` - the area within which the data is being drawn.
    `info` - collects information about the drawing.
    `plot` - the plot (can be used to obtain standard color information etc).
    `domainAxis` - the domain (horizontal) axis.
    `rangeAxis` - the range (vertical) axis.
    `dataset` - the dataset.
    `series` - the series index (zero-based).
    `item` - the item index (zero-based).
    `crosshairState` - crosshair information for the plot (`null` permitted).
    `pass` - the pass index.

### drawItemPass0

    protected void drawItemPass0(java.awt.Graphics2D g2,
                                 java.awt.geom.Rectangle2D dataArea,
                                 PlotRenderingInfo info,
                                 XYPlot plot,
                                 ValueAxis domainAxis,
                                 ValueAxis rangeAxis,
                                 XYDataset dataset,
                                 int series,
                                 int item,
                                 CrosshairState crosshairState)

  Draws the visual representation of a single data item, first pass.

  Parameters:
    `g2` - the graphics device.
    `dataArea` - the area within which the data is being drawn.
    `info` - collects information about the drawing.
    `plot` - the plot (can be used to obtain standard color information etc).
    `domainAxis` - the domain (horizontal) axis.
    `rangeAxis` - the range (vertical) axis.
    `dataset` - the dataset.
    `series` - the series index (zero-based).
    `item` - the item index (zero-based).
    `crosshairState` - crosshair information for the plot (`null` permitted).

### drawItemPass1

    protected void drawItemPass1(java.awt.Graphics2D g2,
                                 java.awt.geom.Rectangle2D dataArea,
                                 PlotRenderingInfo info,
                                 XYPlot plot,
                                 ValueAxis domainAxis,
                                 ValueAxis rangeAxis,
                                 XYDataset dataset,
                                 int series,
                                 int item,
                                 CrosshairState crosshairState)

  Draws the visual representation of a single data item, second pass. In the second pass, the renderer draws the lines and shapes for the individual points in the two series.

  Parameters:
    `g2` - the graphics device.
    `dataArea` - the area within which the data is being drawn.
    `info` - collects information about the drawing.
    `plot` - the plot (can be used to obtain standard color information etc).
    `domainAxis` - the domain (horizontal) axis.
    `rangeAxis` - the range (vertical) axis.
    `dataset` - the dataset.
    `series` - the series index (zero-based).
    `item` - the item index (zero-based).
    `crosshairState` - crosshair information for the plot (`null` permitted).

### getPositiveArea

    protected java.awt.Shape getPositiveArea(float x0,
                                             float y0A,
                                             float y0B,
                                             float x1,
                                             float y1A,
                                             float y1B,
                                             PlotOrientation orientation)

  Returns the positive area for a crossover point.

  Parameters:
    `x0` - x coordinate.
    `y0A` - y coordinate A.
    `y0B` - y coordinate B.
    `x1` - x coordinate.
    `y1A` - y coordinate A.
    `y1B` - y coordinate B.
    `orientation` - the plot orientation.
  Returns:
    The positive area.

### getNegativeArea

    protected java.awt.Shape getNegativeArea(float x0,
                                             float y0A,
                                             float y0B,
                                             float x1,
                                             float y1A,
                                             float y1B,
                                             PlotOrientation orientation)

  Returns the negative area for a cross-over section.

  Parameters:
    `x0` - x coordinate.
    `y0A` - y coordinate A.
    `y0B` - y coordinate B.
    `x1` - x coordinate.
    `y1A` - y coordinate A.
    `y1B` - y coordinate B.
    `orientation` - the plot orientation.
  Returns:
    The negative area.

### getLegendItem

    public LegendItem getLegendItem(int datasetIndex,
                                    int series)

  Returns a default legend item for the specified series. Subclasses should override this method to generate customised items.

  Specified by:
    `getLegendItem` in interface `XYItemRenderer`
  Overrides:
    `getLegendItem` in class `AbstractXYItemRenderer`
  Parameters:
    `datasetIndex` - the dataset index (zero-based).
    `series` - the series index (zero-based).
  Returns:
    A legend item for the series.

### equals

    public boolean equals(java.lang.Object obj)

  Tests this renderer for equality with an arbitrary object.

  Overrides:
    `equals` in class `AbstractXYItemRenderer`
  Parameters:
    `obj` - the object (`null` permitted).
  Returns:
    A boolean.

### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

  Returns a clone of the renderer.

  Specified by:
    `clone` in interface `org.jfree.util.PublicCloneable`
  Overrides:
    `clone` in class `AbstractXYItemRenderer`
  Returns:
    A clone.
  Throws:
    `java.lang.CloneNotSupportedException` - if the renderer cannot be cloned.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD